sysopen INPUT, $ARGV[0], 2;
$len = sysseek(INPUT, 0, 2);
print "file length: $len\n";
die if $len & 3 or $len<4;
sysseek INPUT, 0, 0;
sysread INPUT, $data, $len;
$crc = 0xFFFFFFFF;
for ($i=0; $i<$len-4; $i++)
{
  $byte=vec($data,$i,8);
  for ($j=0; $j<8; $j++)
  {
    $val = $byte>>7;
    $val ^= $crc>>31;
    $crc &= 0x7FFFFFFF;
    $crc <<= 1;
    # x32+x26+x23+x22+x16+x12+x11+x10+x8+x7+x5+x4+x2+x+1
    $crc ^= 0x04C11DB7 if $val;
    $byte &= 0x7F;
    $byte <<= 1;
  }
}
$crc ^= 0xFFFFFFFF;
print "compute crc: ". unpack('H*',pack('N',$crc)) ."\n";
for ($i=$len-4; $i<$len; $i++)
{
  $byte = $crc & 0xFF;
  $crc >>= 8;
  vec($data,$i,8) = $byte;
}
sysseek INPUT, -4, 1;
syswrite INPUT, $data, 4, -4;
close INPUT;

